import { userQueryKeys } from '../user-query-keys';
import { userApi, type PostGetFriendsDataReturn } from '../user-api';

import type { BaseAxiosError } from '../../../../types';

import { useMutation } from '@tanstack/react-query';

export const useGetFriendsMutation = () => {
  return useMutation<
    PostGetFriendsDataReturn,
    BaseAxiosError,
    { id: number; page: number; sort?: string; age?: number; country?: string },
    PostGetFriendsDataReturn
  >({
    mutationKey: userQueryKeys.getFriends(),
    mutationFn: async (variables) => {
      const response = await userApi.getFriends(
        variables.id,
        variables.page,
        variables.sort,
        variables.age,
        variables.country
      );
      return response.data;
    }
  });
};
